-- ResourceTracker
-- Author: Davii
-- DateCreated: 9/27/2012 5:27:43 AM
--------------------------------------------------------------
-- Intended for watching how game tracks additional resources
--------------------------------------------------------------

include("SupportFunctions");

local mapMaxX, mapMaxY = Map.GetGridSize();

--------------------------------------------------------------

function RunResourceChecker()

	GetNumResources()
	CheckGlobalResources()
	ResetImprovements()
	--CheckPlotHasResourceAndImprovement()

end

--------------------------------------------------------------

function GetNumResources() --check to see what resources the game believes the player has

	local iPlayer = Game.GetActivePlayer();
	local pPlayer = Players[iPlayer];
	local pPlayerTeam = Game.GetActiveTeam();
	
	local pPlayerID = pPlayer:GetID();

	for resource in GameInfo.Resources() do

		local resourceID = resource.ID;
		local resourceDesc = resource.Description;
		local resourceNum = pPlayer:GetNumResourceTotal(resourceID);

		if (resourceNum > 0) then

			print(string.format(" Player %i has %i of %s", pPlayerID, resourceNum, resourceDesc));
	
		end	
	end
end

--------------------------------------------------------------

function CheckGlobalResources() --check whether appearance of discovered resources from enhanced mines show up globally (true)

	for resource in GameInfo.Resources() do

		local resourceID = resource.ID;
		local resourceDesc = resource.Description;
		
		local numResources = Map.GetNumResources(resourceID);

		if (numResources > 0) then

			print(string.format(" GLOBAL resources: %i of %s", numResources, resourceDesc));

		end
	end
end

--------------------------------------------------------------

function ResetImprovements(iHexX, iHexY) --check for improvement upgrade with resource

	local iPlayer = Game.GetActivePlayer();
	local pPlayer = Players[iPlayer];
	local pPlayerTeam = Game.GetActiveTeam();
	
	local pPlayerID = pPlayer:GetID();

	local pPlot = Map.GetPlot(ToGridFromHex(iHexX, iHexY));
	local pPlotID = pPlot:GetX() + pPlot:GetY() * mapMaxX;
	local iResource = pPlot:GetResourceType();
	local iImprovement = pPlot:GetImprovementType();

	print(iResource); --returned -1
	print(iImprovement); --returned -1
	print(pPlot); --returned table
	print(pPlotID); --returned 0

	if (pPlot ~= nil) then
	--if (iResource ~= -1) then

		if (iImprovement == GameInfoTypes.IMPROVEMENT_ENHANCED_MINE) then

			print(" Enhanced Mine found at plot: ", pPlotID);

			AddImprovedResource(pPlot, pPlayerID, pPlayerTeam);
			--if (iResource == GameInfoTypes.RESOURCE_COAL) then
	


		end
	
	else

		print(" pPlot returned nil ");

	end
end

--------------------------------------------------------------

function AddImprovedResource(pPlot, pPlayerID, pPlayerTeam)

	local iResourceID = pPlot:GetResourceType(pPlayerTeam);
	local iResourceNum = pPlot:GetNumResource();

	if ( iResourceID > -1 and iResourceNum > 0 ) then

		pPlayer:ChangeNumResourceTotal(iResourceID, iResourceNum);

	end
end

--------------------------------------------------------------

Events.ActivePlayerTurnStart.Add(RunResourceChecker);